#include <Xm/Xm.h>
#include "global.h"

void v_cb(Widget widget, XtPointer client_data, XtPointer call_data) {
  int           i, item, nactive;
  unsigned long n, n1, n2;
  Arg           args[5];
  Widget        mbox;

  extern void da_cb(Widget widget, XtPointer client_data, XtPointer call_data);
  extern void showmess(Widget widget, char *title, char *text);
  extern Widget GetTopLevelShell(Widget w);

  item=(int) client_data;
  switch(item) {
  case 0:      // redraw;
    da_cb(NULL, NULL, NULL);
    break;
  case 1:      // zoom;
    r.t_1=r.ts_1; r.t_2=r.ts_2;
    for (i=0;i<r.n;i++) {
      n1=(unsigned long)floor(r.t_1*r.ch[i].sr);
      n2=(unsigned long)floor(r.t_2*r.ch[i].sr);
      if (n2>=r.ch[i].n) n2=r.ch[i].n-1;
      if (n1>=r.ch[i].n) n1=r.ch[i].n-1;
      r.view[i].min=r.ch[i].data[n1]; r.view[i].max=r.ch[i].data[n1];
      for (n=n1; n<=n2; n++) {
	if (r.view[i].min>r.ch[i].data[n]) r.view[i].min=r.ch[i].data[n];
	if (r.view[i].max<r.ch[i].data[n]) r.view[i].max=r.ch[i].data[n];
      }
    }
    da_cb(NULL, NULL, NULL);
    break;
  case 2:      // total view;
    r.t_1=0; r.t_2=0;
    for (i=0; i<r.n; i++) {
      r.view[i].max=r.ch[i].max;
      r.view[i].min=r.ch[i].min;
      if (r.view[i].is_visible)
	if ((float)r.ch[i].n/r.ch[i].sr > r.t_2)
	  r.t_2=(float)r.ch[i].n/r.ch[i].sr;
    }
    da_cb(NULL, NULL, NULL);
    break;
  case 3:      // hide active;
    nactive=0;
    for (i=0; i<r.n; i++)
      if (r.view[i].is_active) nactive++;
    if (nactive>0) {
      if (r.nvis-nactive>0) {
	for (i=0; i<r.n; i++)
	  if (r.view[i].is_active) {
	    r.view[i].is_active=0;
	    r.view[i].is_visible=0;
	    r.nvis--;
	  }
	da_cb(NULL, NULL, NULL);
      }
      else 
	showmess(drawing_a, "too many active channels",
		 "At least 1 channel must remain visible!");
    }
    else 
      showmess(drawing_a, "no active channels",
	       "At least 1 channel must be active!");
    break;
  case 4:      // show all;
    if (r.nvis!=r.n) {
      for (i=0; i<r.n; i++) r.view[i].is_visible=1;
      r.nvis=r.n;
      da_cb(NULL, NULL, NULL);
    }
    break;
  case 5:      // view comments;
    XtPopup(GetTopLevelShell(c_list_w), XtGrabNone);
    break;
  }

}
